<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="style.css" />
</head>

<body onload="onPageLoading()">
  <div class="container-fluid">
    <h1 style="display: flex;justify-content: center;">Order Detail!</h1>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="order-code">Order Code</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="order-code" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="size">Cỡ combo</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <select id="size">
              <option value="0">Chọn cỡ combo(Combo size)</option>
            </select>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="duongkinh">Đường kính Pizza</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="duongkinh" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="suongnuong">Sường nướng(miếng)</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="suongnuong" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="drink">Đồ uống</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <select id="drink">
              <option value="0">Chọn đồ uống</option>
            </select>
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="drinkquantity">Số lượng nước uống</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="drinkquantity" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="voucher-id">Voucher Id</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="voucher-id" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="type-pizza">Loại Pizza</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <select id="type-pizza">
              <option value="0">Chọn loại Pizza</option>
            </select>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="salad">Salad</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="salad" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="payment">Thành tiền</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="payment" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="discount">Giảm giá</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="discount" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="fullname">Họ và tên</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="fullname" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="email">Email</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="email" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="phone-number">Số điện thoại</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="phone-number" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="address">Địa chỉ</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="address" type="text">
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="message">Lời Nhắn</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="message" type="text">
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="status">Trạng thái đơn hàng</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <select id="status">
              <option value="0">Trạng thái</option>
            </select>
          </div>
        </div>
      </div>
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="order-day">Ngày tạo đơn</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="order-day" type="text">
          </div>
        </div>

      </div>
    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">
            <label for="update-day">Ngày cập nhật</label>
          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <input id="update-day" type="text">
          </div>
        </div>
      </div>

    </div>
    <div class="row">
      <div class="col col-sm-6 col-md-6 col-lg-6">
        <div class="row">
          <div class="col col-sm-4 col-md-4 col-lg-4">

          </div>
          <div class="col col-sm-8 col-md-8 col-lg-8">
            <button id="btnconfirm" onclick="onBtnConfirmClick()" class="btn btn-success">Confirm</button>
            <button id="btncancel" onclick="onBtnCancelClick()" class="btn btn-info">Cancel</button>
          </div>
        </div>
      </div>

    </div>
  </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm xử lý sự kiện F5
    function onPageLoading() {
      var vUrlString = window.location.href;
      var vUrl = new URL(vUrlString);
      var vOrder = {
        orderCode: "",
        sizeCombo: "",
        duongKinh: "",
        suonNuong: "",
        doUong: "",
        soLuongNuocUong: 0,
        voucherId: 0,
        loaiPizza: "",
        salad: "",
        thanhTien: "",
        giamGia: "",
        hoVaTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai: "",
        ngayTaoDon: "",
        ngayCapNhat: ""
      }

      //B1 thu thập dữ liệu
      getDataToObject(vOrder, vUrl)
      // B2 Kiểm tra Query String
      var vValidate = isDataValidate(vOrder)
      if (vValidate == true) {
        // B3 Gọi Api xử lý
        var xhr = new XMLHttpRequest()
        processApi(vOrder, xhr)
        xhr.onreadystatechange =
          function () {
            if (this.status == gREQUEST_STATUS_OK && this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
              // B4 xử lý hiển thị
              console.log(xhr.responseText)
              displayDataToForm(vOrder, xhr)
            }
          }
      }
    }
    function onBtnConfirmClick(){
      var vUrlString = window.location.href;
      var vUrl = new URL(vUrlString);
      var vOrder = {
        id:"",
        orderCode: "",
        sizeCombo: "",
        duongKinh: "",
        suonNuong: "",
        doUong: "",
        soLuongNuocUong: 0,
        voucherId: 0,
        loaiPizza: "",
        salad: "",
        thanhTien: "",
        giamGia: "",
        hoVaTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai: "",
        ngayTaoDon: "",
        ngayCapNhat: ""
      }
      
      //B1 thu thập dữ liệu
      getIdToEvent(vOrder,vUrl)
      // B2 Kiểm tra dữ liệu[Không có]
      // B3 Gọi API xử lý
      var xhr = new XMLHttpRequest()
      processApiToUpdate(vOrder,xhr)
      xhr.onreadystatechange=
      function(){
        if (this.readyState==gREQUEST_READY_STATUS_FINISH_AND_OK&&this.status==gREQUEST_STATUS_OK){
          var vResponseText = xhr.responseText
          console.log(vResponseText)
          alert("Đơn hàng của bạn đã được xác nhận")
        }
      }
    }
    function onBtnCancelClick(){
      var vUrlString = window.location.href;
      var vUrl = new URL(vUrlString);
      var vOrder = {
        id:"",
        orderCode: "",
        sizeCombo: "",
        duongKinh: "",
        suonNuong: "",
        doUong: "",
        soLuongNuocUong: 0,
        voucherId: 0,
        loaiPizza: "",
        salad: "",
        thanhTien: "",
        giamGia: "",
        hoVaTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai: "",
        ngayTaoDon: "",
        ngayCapNhat: ""
      }
      
      //B1 thu thập dữ liệu
      getIdToEvent(vOrder,vUrl)
      // B2 Kiểm tra dữ liệu[Không có]
      // B3 Gọi API xử lý
      var xhr = new XMLHttpRequest()
      processApiToCancel(vOrder,xhr)
      xhr.onreadystatechange=
      function(){
        if (this.readyState==gREQUEST_READY_STATUS_FINISH_AND_OK&&this.status==gREQUEST_STATUS_OK){
          var vResponseText = xhr.responseText
          console.log(vResponseText)
          alert("Đơn hàng của bạn đã được cancel")
        }
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu cho đối tượng
    function getDataToObject(paramObject, paramUrl) {
      //
      const gORDER_ID = paramUrl.searchParams.get("id")
      const gORDER_CODE = paramUrl.searchParams.get("ordercode")
      // gán vào Object
      paramObject.id = gORDER_ID
      paramObject.orderCode = gORDER_CODE
      console.log("Id là: " + paramObject.id)
      console.log("OrderCode là: " + paramObject.orderCode)
    }
    //Hàm kiểm tra dữ liệu xem Query String có   rỗng không
    function isDataValidate(paramObject) {

      if (!paramObject.id||paramObject.id=="undefined") {
        alert("Không tìm thấy Id")
        
        return window.location.href = "indexListView.html"
      }
      if (!paramObject.orderCode||paramObject.orderCode=="undefined") {
        alert("Không tìm thấy Order Code")
        return window.location.href = "indexListView.html"
      }
      return true
    }
    // hàm gọi Api theo orderCode
    function processApi(paramObject, paramXMLHttpGetAllOrders) {
      const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      paramXMLHttpGetAllOrders.open("GET", vBaseUrl + "/" + paramObject.orderCode, true);
      paramXMLHttpGetAllOrders.send();
    }
    function displayDataToForm(paramObject, paramXMLHttpGetAllOrders) {
      var vResponseObject = JSON.parse(paramXMLHttpGetAllOrders.responseText)
      // Truy xuat gia tri form
      var vDuongKinhInput = document.getElementById("duongkinh")
      var vSuongNuongInput = document.getElementById("suongnuong")
      var vDoUongSelect = document.getElementById("drink")
      var vSoLuongDoUongInput = document.getElementById("drinkquantity")
      var vVoucherIdInput = document.getElementById("voucher-id")
      var vLoaiPizzaSelect = document.getElementById("type-pizza")
      var vSaladInput = document.getElementById("salad")
      var vThanhTienInput = document.getElementById("payment")
      var vGiamGiaInput = document.getElementById("discount")
      var vHoVaTenInput = document.getElementById("fullname")
      var vEmailInput = document.getElementById("email")
      var vSoDienThoaiInput = document.getElementById("phone-number")
      var vDiaChiInput = document.getElementById("address")
      var vLoiNhanInput = document.getElementById("message")
      var vTrangThaiSelect = document.getElementById("status")
      var vNgayTaoDonInput = document.getElementById("order-day")
      var vNgayCapNhatInput = document.getElementById("update-day")
      var vOrderCodeInput = document.getElementById("order-code")
      var vSizeSelect = document.getElementById("size")
      var vSizeOption = document.createElement("option")
      var vDrinkOption = document.createElement("option")
      var vPizzaOption = document.createElement("option")
      var vStatusOption = document.createElement("option")
      var vBtnConfirm = document.getElementById("btnconfirm")
      var vBtnCancel = document.getElementById("btncancel")
      // Gán các giá trị input trả về vào form
      vOrderCodeInput.value = vResponseObject.orderCode
      vDuongKinhInput.value = vResponseObject.duongKinh
      vSuongNuongInput.value = vResponseObject.suon
      vSoLuongDoUongInput.value = vResponseObject.soLuongNuoc
      vVoucherIdInput.value = vResponseObject.idVourcher
      vSaladInput.value = vResponseObject.salad
      vThanhTienInput.value = vResponseObject.thanhTien
      vGiamGiaInput.value = vResponseObject.giamGia
      vHoVaTenInput.value = vResponseObject.hoTen
      vEmailInput.value = vResponseObject.email
      vSoDienThoaiInput.value = vResponseObject.soDienThoai
      vDiaChiInput.value = vResponseObject.diaChi
      vLoiNhanInput.value = vResponseObject.loiNhan
      vNgayTaoDonInput.value = vResponseObject.ngayTao
      vNgayCapNhatInput.value = vResponseObject.ngayCapNhat
      // Thêm option cho chọn cỡ combo và gán vào form khi f5
      vSizeOption.value = vResponseObject.kichCo
      vSizeOption.text = vResponseObject.kichCo
      vSizeSelect.appendChild(vSizeOption)
      vSizeSelect.value = vResponseObject.kichCo
      // Thêm option cho chọn loại nước uống và gán vào form khi f5
      vDrinkOption.value = vResponseObject.idLoaiNuocUong
      vDrinkOption.text = vResponseObject.idLoaiNuocUong
      vDoUongSelect.appendChild(vDrinkOption)
      vDoUongSelect.value = vResponseObject.idLoaiNuocUong
      // Thêm option cho chọn loại pizza và gán vào form khi f5
      vPizzaOption.value = vResponseObject.loaiPizza
      vPizzaOption.text = vResponseObject.loaiPizza
      vLoaiPizzaSelect.appendChild(vPizzaOption)
      vLoaiPizzaSelect.value = vResponseObject.loaiPizza
      // Thêm option cho chọn trạng thái order và gán vào form khi f5
      vStatusOption.value = vResponseObject.trangThai
      vStatusOption.text = vResponseObject.trangThai
      vTrangThaiSelect.appendChild(vStatusOption)
      vTrangThaiSelect.value = vResponseObject.trangThai

    }
    // Hàm thu thập dữ liệu để confirm
function getIdToEvent(paramObject,paramUrl){
  //Truy xuất giá trị từ form
  // var vDuongKinhInput = document.getElementById("duongkinh")
  //     var vSuongNuongInput = document.getElementById("suongnuong")
  //     var vDoUongSelect = document.getElementById("drink")
  //     var vSoLuongDoUongInput = document.getElementById("drinkquantity")
  //     var vVoucherIdInput = document.getElementById("voucher-id")
  //     var vLoaiPizzaSelect = document.getElementById("type-pizza")
  //     var vSaladInput = document.getElementById("salad")
  //     var vThanhTienInput = document.getElementById("payment")
  //     var vGiamGiaInput = document.getElementById("discount")
  //     var vHoVaTenInput = document.getElementById("fullname")
  //     var vEmailInput = document.getElementById("email")
  //     var vSoDienThoaiInput = document.getElementById("phone-number")
  //     var vDiaChiInput = document.getElementById("address")
  //     var vLoiNhanInput = document.getElementById("message")
  //     var vTrangThaiSelect = document.getElementById("status")
  //     var vNgayTaoDonInput = document.getElementById("order-day")
  //     var vNgayCapNhatInput = document.getElementById("update-day")
  //     var vOrderCodeInput = document.getElementById("order-code")
  //     var vSizeSelect = document.getElementById("size")
  //     //Gán vào đối tượng
  //     paramObject.duongKinh = vDuongKinhInput.value.trim()
  //     paramObject.suonNuong = vSuongNuongInput.value.trim()
  //     paramObject.doUong = vDoUongSelect.value.trim()
  //     paramObject.soLuongNuocUong = vSoLuongDoUongInput.value.trim()
  //     paramObject.voucherId = vVoucherIdInput.value.trim()
  //     paramObject.loaiPizza = vLoaiPizzaSelect.value.trim()
  //     paramObject.salad = vSaladInput.value.trim()
  //     paramObject.thanhTien = vThanhTienInput.value.trim()
  //     paramObject.giamGia = vGiamGiaInput.value.trim()
  //     paramObject.hoVaTen = vHoVaTenInput.value.trim()
  //     paramObject.email = vEmailInput.value.trim()
  //     paramObject.soDienThoai = vSoDienThoaiInput.value.trim()
  //     paramObject.diaChi = vDiaChiInput.value.trim()
  //     paramObject.loiNhan = vLoiNhanInput.value.trim()
  //     paramObject.trangThai = "Confirmed"
  //     paramObject.ngayTao = vNgayTaoDonInput.value.trim()
  //     paramObject.ngayCapNhat = vNgayCapNhatInput.value.trim()
  //     paramObject.orderCode = vOrderCodeInput.value.trim()
  //     paramObject.sizeCombo = vSizeSelect.value.trim()
      paramObject.id=paramUrl.searchParams.get("id")
      // ghi ra console id
      console.log("Id là: "+paramObject.id)
}
function processApiToUpdate(paramObject,paramXMLHttpUpdate){
  const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  paramXMLHttpUpdate.open("PUT", vBaseUrl + "/" + paramObject.id, true);
  paramXMLHttpUpdate.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
  var vUpdateObject = {trangThai:"confirmed"}
  paramXMLHttpUpdate.send(JSON.stringify(vUpdateObject));
    
}
function processApiToCancel(paramObject,paramXMLHttpUpdate){
  const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  paramXMLHttpUpdate.open("PUT", vBaseUrl + "/" + paramObject.id, true);
  paramXMLHttpUpdate.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
  var vUpdateObject = {trangThai:"cancel"}
  paramXMLHttpUpdate.send(JSON.stringify(vUpdateObject));
    
}
  </script>
</body>

</html>